# 《HelloGitHub》第 03 期
>兴趣是最好的老师，**HelloGitHub** 就是帮你找到兴趣！
<p align="center">
    <img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/01/img/hello-github.jpg' style="max-width:100%;"></img>
</p>

## 简介
分享 GitHub 上有趣、入门级的开源项目。

这是一个面向**编程新手**、**热爱编程**、**对开源社区感兴趣** 人群的月刊，月刊的内容包括：**各种编程语言的项目**、**让生活变得更美好的工具**、**书籍、学习笔记、教程等**，这些开源项目大多都是非常容易上手，而且非常 Cool。主要是希望大家能动手用起来，加入到**开源社区**中。
- 会编程的可以贡献代码
- 不会编程的可以反馈使用这些工具中的 Bug
- 帮着宣传你觉得优秀的项目
- Star 项目⭐️

在浏览、参与这些项目的过程中，你将学习到**更多编程知识**、**提高编程技巧**、**找到编程的乐趣**。

🎉 最后 [HelloGitHub](https://hellogithub.com) 这个项目就诞生了 🎉

---
> **以下为本期内容**｜每个月 **28** 号发布最新一期｜[点击查看往期内容](https://github.com/521xueweihan/HelloGitHub#内容)

#### CSS 项目
1、[animate.css](https://github.com/daneden/animate.css)：提供炫酷动画效果，同时方便、易用、跨浏览器的 CSS 库。[在线演示](https://daneden.github.io/animate.css/)

2、[mui](https://github.com/dcloudio/mui)：最接近原生 APP 体验的高性能框架。性能和体验的差距，一直是 mobile App 开发者放弃 HTML5 的首要原因。mui 框架有效的解决了这些问题，这是一个可以方便开发出高性能 App 的框架，也是目前最接近原生 App 效果的框架。[mui 官网](http://dev.dcloud.net.cn/mui/)

#### Go 项目
3、[pholcus](https://github.com/henrylee2cn/pholcus)：Pholcus 是 Go 写的重量级爬虫，纯 Go 语言编写的高并发、分布式、重量级爬虫软件，支持单机、服务端、客户端三种运行模式，拥有 Web、GUI、命令行三种操作界面，功能齐全、强大。[使用手册](https://pholcus.gitbooks.io/docs/content/)，使用展示如图：


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/03/img/Pholcus-min.jpg' style="max-width:80%; max-height=80%;"></img></p>

#### Java 项目
4、[greys-anatomy](https://github.com/oldmanpushcart/greys-anatomy)：Greys 是 Java 在线问题诊断工具。

#### JavaScript 项目
5、[OS.js](https://github.com/os-js/OS.js)：JavaScript 写的基于浏览器上的桌面操作系统。[在线演示](https://demo.os-js.org/)，使用展示如图：


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/03/img/os-js-min.png' style="max-width:80%; max-height=80%;"></img></p>

6、[editor.md](https://github.com/pandao/editor.md)：是一款开源的、可嵌入的 Markdown 在线编辑器（组件），基于 CodeMirror、jQuery 和 Marked 构建。[在线尝试](http://lab.lepture.com/editor/)，使用展示如图：


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/03/img/editor.md-min.png' style="max-width:80%; max-height=80%;"></img></p>

#### PHP 项目
7、[walle-web](https://github.com/meolu/walle-web)：Walle（瓦力） 一个 Web 部署系统工具，可能也是个持续发布工具，配置简单、功能完善、界面流畅、开箱即用！支持 git、svn 版本管理，支持各种 Web 代码发布，静态的 HTML，动态 PHP，需要编译的 Java 等。[中文介绍](https://github.com/meolu/walle-web/blob/master/docs/README-zh.md)，使用展示如图：


<p align="center"><img src='https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/03/img/wali-show.gif' style="max-width:80%; max-height=80%;"></img></p>

#### Python 项目
8、[KindleEar](https://github.com/cdhigh/KindleEar)：这是一个运行在 Google App Engine(GAE) 上的 Kindle 个人推送服务应用，生成排版精美的杂志模式 `mobi/epub` 格式自动每天推送至您的 Kindle 或其他邮箱。

#### 其它
9、[css-creating](https://github.com/cssdream/css-creating)：CSS 创作指南



---
<p align="center">
    “看完了，还不够？<a href='https://github.com/521xueweihan/HelloGitHub#%E5%86%85%E5%AE%B9'><往期内容></a> | 还不过瘾，那就看看每天更新的前端日报吧 <a href='https://daily.fairyever.com/'><今日前端></a>”<br>
    如果你发现了好玩、有意义的开源项目 <a href='https://github.com/521xueweihan/HelloGitHub/issues/new'>点击这里</a> 分享你觉得有趣的项目。
</p>

## 公众号
最近开了公众号，后续公众号会针对月刊推荐过的内容精选、梳理，做成系列的文章发布。月刊也会同时发布在公众号，便于第一时间阅读。

<p align="center">
  <img src="https://raw.githubusercontent.com/521xueweihan/img/master/hellogithub/logo/weixin.png" style="max-width:70%;"></img><br>
欢迎关注 HelloGitHub 公众号，获取更多开源项目的资料和内容。
</p>

## 声明
<a rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/"><img alt="知识共享许可协议" style="border-width:0" src="https://i.creativecommons.org/l/by-sa/4.0/88x31.png" /></a><br />本作品采用<a rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/">知识共享署名-相同方式共享 4.0 国际许可协议</a>进行许可。

**欢迎转载，请注明出处和作者，同时保留声明。**
